hdu 2563 递推

  1. #include <stdio.h>
  2. #include <string>
  3. #include <iostream>
  4. #include <string.h>
  5. #include <map>
  6. #define MAX 30
  7. using namespace std;
  8. /*
  9. 一道很好的递推题,虽然思路是从discuss中获得,但是应该想简单些,从前一次走可获得,
  10. 每次向上走可以为下一次获得3步机会,而向左或者向右则只能由两种。
  11. */
  12. int main()
  13. {
  14. int two[MAX] = {0,2}, three[MAX] = {0,1}, result[MAX] = {0,3};
  15. for(int i=2; i<=20; i++)
  16. {
  17. two[i] = two[i-1] + three[i-1] *2;
  18. three[i] = three[i-1] + two[i-1];
  19. result[i] = two[i-1] * 2 + three[i-1] * 3;
  20. }
  21. int T;
  22. scanf("%d", &T);
  23. while(T--)
  24. {
  25. int n;
  26. scanf("%d", &n);
  27. printf("%d\n", result[n]);
  28. }
  29. return 0;
  30. }
  31. /*
  32. Problem Description
  33. 在一无限大的二维平面中,我们做如下假设:
  34. 1、 每次只能移动一格;
  35. 2、 不能向后走(假设你的目的地是“向上”,那么你可以向左走,可以向右走,也可以向上走,但是不可以向下走);
  36. 3、 走过的格子立即塌陷无法再走第二次;
  37. 求走n步不同的方案数(2种走法只要有一步不一样,即被认为是不同的方案)。
  38. Input
  39. 首先给出一个正整数C,表示有C组测试数据
  40. 接下来的C行,每行包含一个整数n (n<=20),表示要走n步。
  41. Output
  42. 请编程输出走n步的不同方案总数;
  43. 每组的输出占一行。
  44. Sample Input
  45. 2
  46. 1
  47. 2
  48. Sample Output
  49. 3
  50. 7
  51. */

来自为知笔记(Wiz)

附件列表

时间: 2024-10-13 04:13:35

hdu 2563 递推的相关文章

hdu 1267 递推

下沙的沙子有几粒? Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4326    Accepted Submission(s): 2268 Problem Description 2005年11月份,我们学校参加了ACM/ICPC 亚洲赛区成都站的比赛,在这里,我们获得了历史性的突破,尽管只是一枚铜牌,但获奖那一刻的激动,也许将永远铭刻

hdu 2044-2050 递推专题

总结一下做递推题的经验,一般都开成long long (别看项数少,随便就超了) 一般从第 i 项开始推其与前面项的关系(动态规划也是这样),而不是从第i 项推其与后面的项的关系. hdu2044:http://acm.hdu.edu.cn/showproblem.php?pid=2044 //没开成long long WA了一次 #include<iostream> #include<cstdio> #include<algorithm> #include <s

hdu 2604 递推 矩阵快速幂

HDU 2604 Queuing (递推+矩阵快速幂) 这位作者讲的不错,可以看看他的 #include <cstdio> #include <iostream> #include <algorithm> #include <cmath> #include <cstring> using namespace std; const int N = 5; int msize, Mod; struct Mat { int mat[N][N]; }; M

HDU 2842 (递推+矩阵快速幂)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2842 题目大意:棒子上套环.第i个环能拿下的条件是:第i-1个环在棒子上,前i-2个环不在棒子上.每个环可以取下或放上,cost=1.求最小cost.MOD 200907. 解题思路: 递推公式 题目意思非常无聊,感觉是YY的. 设$dp[i]$为取第i个环时的总cost. $dp[1]=1$,$dp[2]=2$,前两个环取下是没有条件要求的. 从i=3开始,由于条件对最后的环限制最大,所以从最后一

hdu 1297 递推难题

这题的话,我能玩一年 今天做了很多递推的题,这题无疑是最复杂的 其实可以看出来,2,3,4,5为一类,不妨定义为2型,1,6为一类,定义为1型 规定num[i]为结尾是i的凹槽的数量 我们可以能轻易的推出 sum = num[1]*2+num[2]*4 现在我们开始分析这个递推式的构成 根据第n个凹槽前 能不能构成一把lock,我们将情况分为两类 A:能构成lock 1.如果当前结尾为1类,我们用‘1’分析好了(下面也是用1),n-1的结尾必然不能是‘6’,因为1和6不能直接相连,根据题意就知道

HDU 3123-GCC(递推)

GCC Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 3993    Accepted Submission(s): 1304 Problem Description The GNU Compiler Collection (usually shortened to GCC) is a compiler system produc

hdu 5459 递推

中等递推题: ans[i] = ans[i - 2] + ans[i - 1] + ( sum[i - 2] + cnt[i - 2] * len[i - 1] ) * cnt[i - 1] - sum[i - 1] * cnt[i - 2]; 其中,ans[i]代表答案,cnt[i]代表ith个message中有多少个cff,sum[i]代表ith个message中cff的c的位置的和(从右向左index依次为1,2...),len[i]代表ith个message的长度. 1 #include

HDU 4465 递推与double的精确性

题目大意不多说了 这里用dp[i][0] 代表取完第一个盒子后第二个盒子剩 i 个的概率,对应期望就是dp[i][0] *i dp[i][1] 就代表取完第二个盒子后第一个盒子剩 i 个的概率 dp[i][0]  =  p^(n+1) * (1-p)^(n-i) * C(2*n-i , n-i) = p^(n+1) * (1-p)^(n-i) * (2*n-i)! / (n-i)! / n! dp[i+1][0]  = p^(n+1) * (1-p)^(n-i-1) * C(2*n-i-1 ,

hdu 1297 递推

递推式参考:http://www.2cto.com/kf/201302/190324.html 数据较大,需要用大整数来写. 1 import java.math.*; 2 import java.util.Scanner; 3 4 public class Main 5 { 6 public static void main( String[] args ) 7 { 8 Scanner cin = new Scanner(System.in); 9 BigInteger[] f = new B